Imports System
Imports System.ServiceProcess

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Form Name  : frmMonitor
' Description: User interface to monitor local machine's services.
' Author     : Chockalingam Tirupathi
' Version History
' =================
' 1.0             05-Mar-03
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Public Class frmMonitor
    Inherits System.Windows.Forms.Form
 
    Public arrServices() As ServiceController

   'An array to store service status
    Public arrServiceStatus() As String = {"Continue Pending", "Paused", "Pause Pending", "Running", "Start Pending", "Stopped", "Stop Pending"}


    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub


    Private Sub frmMonitor_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
 
  ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  '	Subroutine Name:  frmMonitor_Load
  ' 	Description    :  Subroutine to get the available services of local machine and add it to the list
  '                       control. To get the services from remote machine pass the machine name as parameter
  '                       for the GetServices method. Return value of Get Services is an array.
  '

  ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        Dim iCounter As Integer

        arrServices = ServiceController.GetServices()

        For iCounter = 0 To arrServices.Length - 1
  
          lstService.Items.Add(arrServices(iCounter).DisplayName)

        Next


    End Sub



    Private Sub lstService_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstService.SelectedIndexChanged

  ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  '	Subroutine Name:  lstService_SelectedIndexChanged
  ' 	Description    :  Subroutine to display the Selected service name and its status.
  ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

        lblServiceValue.Text = arrServices(lstService.SelectedIndex).DisplayName
        lblStatusValue.Text = arrServiceStatus(arrServices(lstService.SelectedIndex).Status)


  '   If service status is Running

        If arrServices(lstService.SelectedIndex).Status = 4 Then
            btnStop.Enabled = True
            btnStart.Enabled = False
        Else
            btnStart.Enabled = True
            btnStop.Enabled = False
        End If

    End Sub

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
  
  ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  '	Subroutine Name:  btnStart_Click
  ' 	Description    :  Subroutine to start the Selected service name  
  ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  
        arrServices(lstService.SelectedIndex).Start()
        arrServices(lstService.SelectedIndex).Refresh()
        btnStart.Enabled = False
        btnStop.Enabled = True
        lblStatusValue.Text = arrServiceStatus(arrServices(lstService.SelectedIndex).Status)
  
   End Sub

    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click
  
  ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  '	Subroutine Name:  btnStop_Click
  ' 	Description    :  Subroutine to stop the Selected service name  
  ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  
       If arrServices(lstService.SelectedIndex).CanStop Then

            arrServices(lstService.SelectedIndex).Stop()
            btnStart.Enabled = True
            btnStop.Enabled = False
            lblStatusValue.Text = arrServiceStatus(arrServices(lstService.SelectedIndex).Status)

        End If

    End Sub

End Class
